import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useCallback } from 'react';
import purebem from 'purebem';
import useToggle from '@billogram/use-toggle';
import FoundationTableRowSearchResultGroup from '../search-result-group/FoundationTableRowSearchResultGroup';
import FoundationTableRowGroupContext from './FoundationTableRowGroupContext';
import './FoundationTableRowGroup.scss';
export default function FoundationTableRowGroup(_ref) {
  var _ref$additionalData = _ref.additionalData,
      additionalData = _ref$additionalData === void 0 ? {} : _ref$additionalData,
      columns = _ref.columns,
      fetchInitial = _ref.fetchInitial,
      isFetching = _ref.isFetching,
      isLast = _ref.isLast,
      isOdd = _ref.isOdd,
      isSearchResult = _ref.isSearchResult,
      item = _ref.item,
      removeItem = _ref.removeItem,
      _ref$searchFields = _ref.searchFields,
      searchFields = _ref$searchFields === void 0 ? [] : _ref$searchFields,
      searchQuery = _ref.searchQuery,
      TableRow = _ref.TableRow,
      TableRowExpandResultGroup = _ref.TableRowExpandResultGroup,
      updateItem = _ref.updateItem;
  var block = purebem('foundation-table-row-group');

  var _useToggle = useToggle(),
      collapse = _useToggle.close,
      expand = _useToggle.open,
      toggleExpanded = _useToggle.toggle,
      isExpanded = _useToggle.value;

  var _useToggle2 = useToggle(),
      unsetHandled = _useToggle2.close,
      setHandled = _useToggle2.open,
      toggleHandled = _useToggle2.toggle,
      isHandled = _useToggle2.value;

  var _useToggle3 = useToggle(),
      unhighlight = _useToggle3.close,
      highlight = _useToggle3.open,
      toggleHighlighted = _useToggle3.toggle,
      isHighlighted = _useToggle3.value;

  var _useToggle4 = useToggle(),
      unsetTransparent = _useToggle4.close,
      setTransparent = _useToggle4.open,
      toggleTransparent = _useToggle4.toggle,
      isTransparent = _useToggle4.value;

  var remove = useCallback(function remove() {
    removeItem(item);
  }, [item, removeItem]);
  var update = useCallback(function update(data) {
    updateItem(_objectSpread({}, item, {
      data: data
    }));
  }, [item, updateItem]);
  var context = {
    collapse: collapse,
    columns: columns,
    expand: expand,
    isExpanded: isExpanded,
    isHandled: isHandled,
    isHighlighted: isHighlighted,
    isTransparent: isTransparent,
    setHandled: setHandled,
    unsetHandled: unsetHandled,
    highlight: highlight,
    unhighlight: unhighlight,
    setTransparent: setTransparent,
    unsetTransparent: unsetTransparent,
    refetchTable: fetchInitial,
    remove: remove,
    toggleExpanded: toggleExpanded,
    toggleHandled: toggleHandled,
    toggleHighlighted: toggleHighlighted,
    toggleTransparent: toggleTransparent,
    update: update
  };
  var _even$expanded$fetchi = {
    even: !isOdd && !isSearchResult,
    expanded: isExpanded,
    fetching: isFetching,
    handled: isHandled,
    highlighted: isHighlighted,
    last: isLast && !isSearchResult,
    odd: isOdd && !isSearchResult,
    search: isSearchResult,
    transparent: isTransparent
  },
      even = _even$expanded$fetchi.even,
      expanded = _even$expanded$fetchi.expanded,
      fetching = _even$expanded$fetchi.fetching,
      handled = _even$expanded$fetchi.handled,
      highlighted = _even$expanded$fetchi.highlighted,
      last = _even$expanded$fetchi.last,
      odd = _even$expanded$fetchi.odd,
      search = _even$expanded$fetchi.search,
      transparent = _even$expanded$fetchi.transparent;
  return React.createElement(FoundationTableRowGroupContext.Provider, {
    value: context
  }, React.createElement("tbody", {
    className: block({
      even: even,
      expanded: expanded,
      fetching: fetching,
      handled: handled,
      highlighted: highlighted,
      last: last,
      odd: odd,
      search: search,
      transparent: transparent
    })
  }, React.createElement(TableRow, {
    additionalData: additionalData,
    data: item.data
  }), isExpanded && TableRowExpandResultGroup !== void 0 ? React.createElement(TableRowExpandResultGroup, {
    additionalData: additionalData,
    data: item.data
  }) : null, isSearchResult ? React.createElement(FoundationTableRowSearchResultGroup, {
    data: item.data,
    fields: searchFields,
    query: searchQuery
  }) : null));
}
//# sourceMappingURL=FoundationTableRowGroup.js.map